/// <summary>
/// C# XBGM# Xbox Game Manager.
///  
/// Copyright (C) 2004  KaYa
/// 
/// 
/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.
/// 
/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.
/// 
/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
/// 
/// Bug fixes, suggestions and comments should be sent to xbgm@kayaweed.net
/// 
/// Change Log:
/// 
/// Revision 0.1  2005/07/14 KaYa
/// first release
///
/// Project created on 14/07/2005 at 14:52
///
/// </summary>

using System;

namespace Xbgm.Core
{
	public class CheckEnvOs 
	{
		public CheckEnvOs()
		{
		/*	Show all  environment Variables
			IDictionary    environmentVariables = Environment.GetEnvironmentVariables();
	    	foreach (DictionaryEntry de in environmentVariables)
	        {
	        Console.WriteLine("  {0} = {1}", de.Key, de.Value);
	        }
		*
		* We set and create the xbgmsharp directory
		* to create and save configuration files and data
		* in the user home environment directory 
		* depending on the OS
		* WIN32 = USERPROFILE + "/xbgmsharp"
		* UNIX Linux  = HOME + "/.xbgmsharp"
		* UNIX Mac = HOME + "/xbgmsharp"
		* */
			#if (DEBUG)
				Console.WriteLine("OSVersion: {0}\nOSVersion.Platform: {1}\nOSVersion.Version: {2}\n", 
		        		        Environment.OSVersion.ToString(),
	    	            		Environment.OSVersion.Platform.ToString(),
	        	           		Environment.OSVersion.Version.ToString());
			#endif
			string workingdir = "";
			if (Environment.OSVersion.Platform.ToString().StartsWith("Win")) {
					#if (DEBUG)
						Console.WriteLine("Running Windows");
					#endif
					#if (GUI)
						if (System.IO.File.Exists("gtkrc")) { Gtk.Rc.Parse("gtkrc"); }
					#endif
					workingdir = Environment.GetEnvironmentVariable("USERPROFILE") + "\\xbgmsharp";
			} 
			else if (Environment.OSVersion.ToString().StartsWith("Unix") )
		    {
		        if (Environment.OSVersion.Version.ToString().StartsWith("2.4") |
			      	Environment.OSVersion.Version.ToString().StartsWith("2.6")) 
				{
			         	#if (DEBUG)
			         		Console.WriteLine("Running Linux kernel 2.4 or 2.6");
			         	#endif
			         	workingdir = Environment.GetEnvironmentVariable("HOME") + "/.xbgmsharp";
				}
				else if (Environment.OSVersion.Version.ToString().StartsWith("8.")) 
				{
						#if (DEBUG)
							Console.WriteLine("Running Mac OS X");
						#endif
						workingdir = Environment.GetEnvironmentVariable("HOME") + "/xbgmsharp";
				}
			}
			if (!System.IO.Directory.Exists(workingdir))
				System.IO.Directory.CreateDirectory(workingdir);
			System.IO.Directory.SetCurrentDirectory(workingdir);			
			#if (DEBUG)
				Console.WriteLine("Working Directory: {0}\n", workingdir);
			#endif
		}  
	}
	
}
  
