/// <summary>
/// C# XBGM# Xbox Game Manager.
///  
/// Copyright (C) 2004  KaYa
/// 
/// 
/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.
/// 
/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.
/// 
/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
/// 
/// Bug fixes, suggestions and comments should be sent to xbgm@kayaweed.net
/// 
/// Change Log:
/// 
/// Revision 0.1  2004/07/27 KaYa
/// first release
///
/// </summary>

using System;
using System.Collections;
using System.IO;
using System.Threading;
using Gtk;
using Gdk;
using GtkSharp;
using Xbgm.Xiso;
using Xbgm.Core;
//using Xbgm;

/// <summary>
/// So here is the All GUI in GTK# 
/// There is also all event_callback for the primary window And xbox Stuff
/// </summary>
namespace Xbgm.Gui
{

/// <summary>
/// So here is the All GUI in GTK# 
/// There is also all event_callback for the primary window And xbox Stuff
/// </summary>
public class MyWindow : Gtk.Window {
		const string VERSION = "0.9.1.0_dev";
		const string NAME = "XBGM#";
		const string WELCOME = ", Copyright (C) 2004-2006 KaYa <xbgm@kayaweed.net>. \nIf you have any questions, comments, or suggestions about this program, please feel free to email them to me. \nYou can always find out the latest news about XBGM# from the official website at http://xbgm.sourceforge.net/.\nXBGM# comes with ABSOLUTELY NO WARRANTY; for details, see the COPYING file. \nThis is free software, and you are welcome to redistribute it under certain conditions; for details, see the COPYING file\n";

// Define Linux OS for no thread
//		bool 		Linux = false;
// Info on the selected game. 4 string:  0: Name 1:xbe name 2: directory name 3: ID
		public ArrayList	CurrentGame = null;
		
// The XBMG configuration
		//public Xbgm.Configuration cfg;
		public Xbgm.Config config;
		
// Ftp Operations
		public FtpToXbox ftpToXbox;
		
// Popup message (Info & Error) 
		private Popup popup;

		private XisoInfoClass iso = null;
	
//		bool freespace = false;
		bool deletesave = false;
			
	//	Ftp Thread
	Thread ftp_worker;
	ThreadNotify main_notify;
	
	#region Gtk# GUI declaration
		public Tooltips tooltips;
	//Notebook1
		private HPaned top;
		private Menu menu = null;
		private ListStore store = null;	
		private Gtk.TreeIter iter;
		private Gtk.TreeView tv;

		private Gtk.Image image;
		private Pixbuf pix;
	
		private Label labelDashboard;
		private Label labelIDresult;
		private Label labelSpaceresult;
		private Label labelSlackresult;
		private Label labelPathresult;
		//private Label labelAllFreespace;
		private Label labelAlltitlesResult;
		private Label labelAllfilesResult;
		private Label labelAllfoldersResult;
		private Label labelAllspaceResult;
		private Label labelAllslackResult;
		private Label labelAllsizeResult;
		//private Label labelAllFreespaceResult;
		
		private Label labelResultDriveC;
		private Label labelResultDriveE;
		private Label labelResultDriveF;
		private Label labelResultDriveG;
		private Label DriveG;
		
		public CheckButton DLicons;
	
	//Notebook2
		private ListStore store2 = null;
		private Gtk.TreeIter iter2;
		private Gtk.TreeIter xboxsiter;
		private Gtk.TreeView tv2;
		private Menu menuiso = null;
		
		private Label labelR1;
		private Label labelR2;
		private Label labelR3;
		private Entry Entrygamexbe;
		private Entry Entrygamedir;
		private Entry Entryxboxdir;

		private Label labelnbbatchentry;
		private Label labelnbbatchsize;
		private Label labelnbbatchfiles;
		
		private CheckButton	halticons;
		public 	ComboBox 	XboxsConnectionCombo = null;
	//Notebook3


	//Notebook4
		public TextView textview;
		public TextBuffer buf;
		
	// After Notebook add a statusbar
		public Statusbar statusbar;
		public Label 	statuslabelconnexion;
		public Gtk.Image OnLineStatusImg;
	#endregion
	
	/// <summary>
	/// Create the Main GTK# GUI
	/// </summary>
	public MyWindow () : base ("MyWindow")
	{
		#if (DEBUG)
		Console.WriteLine(NAME + VERSION);
		#endif
		CheckEnvOs checkenvos = new CheckEnvOs();
		checkenvos = null;
		
		// Init the XBGM configuration
		config = new Config();
		// Active Connection & G Drive	
		config.SetDefaultToActive();
		int Index = config.GetIndexActive();
		
		this.popup = new Popup(this);
	 
		this.ftpToXbox = new FtpToXbox(ref config, popup);
		this.ftpToXbox.notifyViews += new Notifier(this.updateLabelResults);
		this.ftpToXbox.EventUpdated += new EventHandler(EventFtpThread);
		this.ftpToXbox.loggerViews += new Logger(this.LogMsg);
		this.ftpToXbox.StatusViews += new UpdateStatus(this.OnLine);
	 
	#region Create Main GUI
	 try{
			this.SetDefaultSize (840, 560);
			this.Title = NAME + " " + VERSION;
			this.DeleteEvent += new DeleteEventHandler (OnMyWindowDelete);
			this.BorderWidth = 2;
	 	
	 		// Set the app icon
	 		Gdk.Pixbuf Icon = new Gdk.Pixbuf(null, "xbgmicon.png");
			this.Icon = Icon;
			
			tooltips = new Tooltips ();

			// 1 first split in line		
			VBox vbox = new VBox (false, 0); 
			this.Add (vbox);
	 	
			// Create the Top Toolbar.
			MyToolbar CreateToolbar = new MyToolbar (this);
			Toolbar Toptoolbar = CreateToolbar.CreateTopToolbar ();
			vbox.PackStart (Toptoolbar, false, false, 0);

//=================================================
// 			NoteBook 1 Manage Title
			#region NoteBook 1
			Notebook nb = new Notebook ();
	 		VBox vboxnb1 = new VBox (false, 0);
	 		nb.Add(vboxnb1);

	 		nb.SetTabLabelText(vboxnb1, "Manage Titles On Xbox");
	 		vbox.PackStart (nb, true, true, 0);

			// Create the Toolbar.
			Toolbar Gametoolbar = CreateToolbar.CreateGameToolbar ();
			vboxnb1.PackStart (Gametoolbar, false, false, 0);

			// Add Horizontal Frame
			top = new HPaned ();
			top.Position = 680;
			vboxnb1.PackStart (top, true, true, 0);
			top.BorderWidth = 0;
			
			// Add a scrolledWindows for the GameList
			ScrolledWindow sw = new ScrolledWindow ();
			top.Add1 (sw);
			
			// Create the treeview containing 6 strings visible + 5 string hiden
			store = new ListStore (typeof (string),
									typeof (Int64),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string)									
								);
	
			// sort by on name for column 0
			//store.SetSortColumnId(0, 0);
			tv = new TreeView (store);
			tv.HeadersVisible = true;
	 		// I don't know what that but why not?
			//tv.Reorderable = true;
	 		
	 		// Right Click 
	 		// Connect signals for mouse button press and popup menu
            tv.ButtonPressEvent += new ButtonPressEventHandler (OnTreeviewButtonPressEvent);
            tv.PopupMenu += new PopupMenuHandler (PopupMenuCb); 
	 	
			// Got left clickable
			// This crash if not using the mono1.0 command line on WIN32
			// Suppress the crash by catch exception but the GUi it is not fully functional.
			tv.Selection.Changed += new EventHandler(on_List_selection);
	 	
			// This is bad but if i don't it that way.
			// it is segfaulting on Win32
			// Add column 1
			TreeViewColumn column = new TreeViewColumn ();
			CellRendererText text = new CellRendererText ();
			column.Title = "Title";
			column.Resizable = true;
			column.SortColumnId = 0;
	 		column.MinWidth = 100;
			column.Sizing = TreeViewColumnSizing.Autosize;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 0);
			tv.AppendColumn(column);

			// 2
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "Size MB";
			column.Resizable = true;
			column.SortColumnId = 1;
			
			column.Sizing = TreeViewColumnSizing.Autosize;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 1);
			tv.AppendColumn(column);
			
			// 3 
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "Folder";
			column.Resizable = true;
	 		column.Reorderable = true;
			column.SortColumnId = 0;
			column.MinWidth = 200;
			// specified the size of the column Folder
			/*column.Sizing = TreeViewColumnSizing.Fixed;
			column.FixedWidth = 260;
			*/
			column.Sizing = TreeViewColumnSizing.Autosize;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 2);
			tv.AppendColumn(column);
			
			// 4
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "Files";
			column.Resizable = true;
			column.SortColumnId = 0;
			
			column.Sizing = TreeViewColumnSizing.Autosize;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 3);
			tv.AppendColumn(column);
			
			// 5
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "Folders";
			column.Resizable = true;
			column.SortColumnId = 0;
			column.MinWidth = 5;
			column.Sizing = TreeViewColumnSizing.Autosize;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 4);
			tv.AppendColumn(column);

			// 6
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "Region";
			column.Resizable = true;
			column.SortColumnId = 5;
			column.MinWidth = 5;
		/*	column.MaxWidth = 5;
	 		column.FixedWidth = 5;
	 		column.Sizing = TreeViewColumnSizing.Fixed;
		*/	column.Sizing = TreeViewColumnSizing.Autosize;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 5);
			tv.AppendColumn(column);

			// 7 hidden ID
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "ID";
			column.Visible = false;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 6);
			tv.AppendColumn(column);
			
			// 8 hidden Space
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "Space";
			column.Visible = false;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 7);
			tv.AppendColumn(column);
			
			// 9 hidden Slack
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "Slack";
			column.Visible = false;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 8);
			tv.AppendColumn(column);
			
			// 10 hidden XBE
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "XBE";
			column.Visible = false;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 9);
			tv.AppendColumn(column);
			
			// 11 hidden DIR
			column = new TreeViewColumn ();
			text = new CellRendererText ();
			column.Title = "Dir";
			column.Visible = false;
			column.PackStart (text, true);
			column.AddAttribute (text, "text", 10);
			tv.AppendColumn(column);
			sw.Add(tv);
			
			// Split for the right view 			
			VBox vboxinside = new VBox (false, 0); 
			//vboxinside.Visible = true;
			vboxinside.Visible = false;
			top.Add2 (vboxinside);					
		
			// Now that is split 
			labelDashboard = new Label ("Dashboard");
			vboxinside.PackStart (labelDashboard);
			
			// Add the image view
			// Don't show image if check box not Active.
			// Old way to get image from file V0.1
			//pix = GetPixbufFromFile ("xbgm.png"); 
	 		// New way to get image from resource V0.2
	 		pix = new Gdk.Pixbuf (null, "xbgmsharp.png");	
	        image = new Gtk.Image (pix);  // OK
	 	
			vboxinside.PackStart (image);
			
			// Add a frame with a label Title view
			Frame frame = new Frame (" Selected Title ");
			frame.BorderWidth = 3;
			vboxinside.PackStart (frame);

			Table table = new Table (4, 2, true);
	 		//table.SetColSpacing(1, 50);
	 		table.Homogeneous = true;
			frame.Add (table);

			Label labelID = new Label ("ID: ");
			labelID.SetAlignment(1,1);
			table.Attach (labelID, 0, 1, 0, 1);

			Label labelSpace = new Label ("Space:  ");
			labelSpace.SetAlignment(1,2);
			table.Attach (labelSpace,0, 1, 0, 2);

			Label labelSlack = new Label ("Slack:  ");
			labelSlack.SetAlignment(1,3);
			table.Attach (labelSlack, 0, 1, 0, 3);
		
			Label labelPath = new Label ("Path:  ");
			labelPath.SetAlignment(1,4);
			table.Attach (labelPath, 0, 1, 0, 4);

			// Result Labels
			labelIDresult = new Label ("");
			labelIDresult.SetAlignment(0,1);
			table.Attach (labelIDresult, 1, 2, 0, 1);
		
			labelSpaceresult = new Label ("");
			labelSpaceresult.SetAlignment(0,2);
			table.Attach (labelSpaceresult, 1, 2, 0, 2);

			labelSlackresult = new Label ("");
			labelSlackresult.SetAlignment(0,3);
			table.Attach (labelSlackresult, 1, 2, 0, 3);
		
			labelPathresult = new Label ("");
			labelPathresult.SetAlignment(0,4);
			table.Attach (labelPathresult, 1, 2, 0, 4);
			
			// Add a frame label All Titles
			frame = new Frame (" All Titles ");
			frame.BorderWidth = 3;
		
			vboxinside.PackStart (frame);
			
			Table table2 = new Table (6, 2, true);
			frame.Add (table2);

			Label labelAlltitles = new Label ("Titles:  ");
			labelAlltitles.SetAlignment(1,1);
			table2.Attach (labelAlltitles, 0, 1, 0, 1);

			Label labelAllfiles = new Label ("Files:  ");
			labelAllfiles.SetAlignment(1,2);
			table2.Attach (labelAllfiles,0, 1, 0, 2);

			Label labelAllfolders = new Label ("Folders:  ");
			labelAllfolders.SetAlignment(1,3);
			table2.Attach (labelAllfolders, 0, 1, 0, 3);
		
			Label labelAllsize = new Label ("Size:  ");
			labelAllsize.SetAlignment(1,4);
			table2.Attach (labelAllsize, 0, 1, 0, 4);
		
			Label labelAllspace = new Label ("Space:  ");
			labelAllspace.SetAlignment(1,5);
			table2.Attach (labelAllspace, 0, 1, 0, 5);

			Label labelAllslack = new Label ("Slack:  ");
			labelAllslack.SetAlignment(1,6);
			table2.Attach (labelAllslack , 0, 1, 0, 6);
	 	 	
			// Result Labels
			labelAlltitlesResult = new Label ("");
			labelAlltitlesResult.SetAlignment(0,1);
			table2.Attach (labelAlltitlesResult, 1, 2, 0, 1);

			labelAllfilesResult = new Label ("");
			labelAllfilesResult.SetAlignment(0,2);
			table2.Attach (labelAllfilesResult, 1, 2, 0, 2);

			labelAllfoldersResult = new Label ("");
			labelAllfoldersResult.SetAlignment(0,3);
			table2.Attach (labelAllfoldersResult, 1, 2, 0, 3);
		
			labelAllsizeResult = new Label ("");
			labelAllsizeResult.SetAlignment(0,4);
			table2.Attach (labelAllsizeResult, 1, 2, 0, 4);
		
			labelAllspaceResult = new Label ("");
			labelAllspaceResult.SetAlignment(0,5);
			table2.Attach (labelAllspaceResult, 1, 2, 0, 5);

			labelAllslackResult = new Label ("");
			labelAllslackResult.SetAlignment(0,6);
			table2.Attach (labelAllslackResult, 1, 2, 0, 6);
			
			// Add a frame label Free space
			frame = new Frame (" Free Drive space ");
			frame.BorderWidth = 3;
			
			vboxinside.PackStart (frame);
			
			Table table3 = new Table (3, 1, true);
			frame.Add (table3);

			Label DriveC = new Label ("C:  ");
			DriveC.SetAlignment(1,1);
			table3.Attach (DriveC, 0, 1, 0, 1);

			Label DriveE = new Label ("E:  ");
			DriveE.SetAlignment(1,2);
			table3.Attach (DriveE,0, 1, 0, 2);

			Label DriveF = new Label ("F:  ");
			DriveF.SetAlignment(1,3);
			table3.Attach (DriveF, 0, 1, 0, 3);
		
			DriveG = new Label ("G:  ");
			DriveG.SetAlignment(1,4);
			table3.Attach (DriveG, 0, 1, 0, 4);
		 	
			// Result Labels
			labelResultDriveC = new Label ("");
			labelResultDriveC.SetAlignment(0,1);
			table3.Attach (labelResultDriveC, 1, 2, 0, 1);

			labelResultDriveE = new Label ("");
			labelResultDriveE.SetAlignment(0,2);
			table3.Attach (labelResultDriveE, 1, 2, 0, 2);

			labelResultDriveF = new Label ("");
			labelResultDriveF.SetAlignment(0,3);
			table3.Attach (labelResultDriveF, 1, 2, 0, 3);
		
			labelResultDriveG = new Label ("");
			labelResultDriveG.SetAlignment(0,4);
			table3.Attach (labelResultDriveG, 1, 2, 0, 4);
			
			DLicons = new CheckButton();
			DLicons.Label = "Download icons";
			DLicons.Active = true;
			vboxinside.PackStart (DLicons, false, false, 0);
			// end the inside Vbox 
			#endregion
//======================================

//=================================================
// 			NoteBook 2 Upload ISO
			#region NoteBook 2
			
			VBox vboxnb2 = new VBox (false, 0);
	 		nb.Add(vboxnb2);
	 		nb.SetTabLabelText(vboxnb2, "Load ISO");
		
	 		Toolbar toolbar3 = CreateToolbar.CreateISOToolbar ();
			vboxnb2.PackStart (toolbar3, false, false, 0);
	 	
			// Add Vertical Frame
			VPaned vpan = new VPaned ();
			vpan.Position = 290;
			vboxnb2.PackStart (vpan, true, true, 0);
			vpan.BorderWidth = 0;

	 		// Add a scrolledWindows for the ISOList
			ScrolledWindow sw2 = new ScrolledWindow ();

	 		vpan.Add(sw2);
	 	
			// Create the treeview containing 6 string visible + 5 string hide
			store2 = new ListStore (typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),
									typeof (string),									
									typeof (string));
			
			// sort by on name for column 0
			//store2.SetSortColumnId(0, 0);
			tv2 = new TreeView (store2);
			tv2.HeadersVisible = true;
			tv2.Selection.Changed += new EventHandler(on_ISOList_selection);

			// Right Click 
	 		// Connect signals for mouse button press and popup menu
            tv2.ButtonPressEvent += new ButtonPressEventHandler (OnTreeviewUploadISOButtonPressEvent);
            tv2.PopupMenu += new PopupMenuHandler (PopupMenuIsoCb); 
			
			// This is bad but if i don't it that way.
			// if i don't it is segfaulting on Win32
			// Add column 1
			TreeViewColumn column2 = new TreeViewColumn ();
			CellRendererText text2 = new CellRendererText ();
			column2.Title = "XBE Title";
			column2.Resizable = true;
			column2.SortColumnId = 0;
	 	
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 0);
			tv2.AppendColumn(column2);

			// 2
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "Size";
			column2.Resizable = true;
			column2.SortColumnId = 0;
			
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 1);
			tv2.AppendColumn(column2);
			
			// 3 
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "Game Folder";
			column2.Resizable = true;
			column2.SortColumnId = 0;
			column2.Sizing = TreeViewColumnSizing.Autosize;
						
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 2);
			tv2.AppendColumn(column2);
			
			// 4
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "Filename";
			column2.Resizable = true;
			column2.SortColumnId = 0;
			
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 3);
			tv2.AppendColumn(column2);
	 	
			// 5
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "Region";
			column2.Resizable = true;
			column2.SortColumnId = 0;
			
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 4);
			tv2.AppendColumn(column2);
			
			// 6 ISO Upload info
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "Xbox Folder";
			column2.Visible = true;
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 5);
			tv2.AppendColumn(column2);
			
			// 7 ISO Upload info
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "files";
			column2.Visible = false;
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 6);
			tv2.AppendColumn(column2);
			
			// 8 ISO Upload info
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "folders";
			column2.Visible = false;
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 7);
			tv2.AppendColumn(column2);

			// 9 ISO Upload info
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "xisofullfilename";
			column2.Visible = false;
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 8);
			tv2.AppendColumn(column2);
			
			// 10 ISO Upload info
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "iso.totfilesize";
			column2.Visible = false;
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 9);
			tv2.AppendColumn(column2);

			// 10 ISO Upload info
			column2 = new TreeViewColumn ();
			text2 = new CellRendererText ();
			column2.Title = "Xbox Connection";
			column2.Visible = true;
			column2.Sizing = TreeViewColumnSizing.Autosize;
			column2.PackStart (text2, true);
			column2.AddAttribute (text2, "text", 10);
			tv2.AppendColumn(column2);
			
			sw2.Add(tv2);
	 		
	 		HBox hboxnb6 = new HBox (false, 0);
	 		vpan.Add(hboxnb6);
	 		
	 		// Add a frame with a label Title view
			Frame frameTransfertOptions = new Frame (" Transfert Options ");
			frameTransfertOptions.BorderWidth = 5;
	 		//vpan.Add(frameTransfert Options);
	 		hboxnb6.PackStart (frameTransfertOptions, true, true, 5);
	 	
		#region	 ISOoption
	
		VBox vboxnb3 = new VBox (false, 0);
		vboxnb3.BorderWidth = 5;
		HBox hboxnbinfo1 = new HBox (false, 0);
	 		Label labelSize = new Label();
	 	/*	Need pango-markup
	 	 * labelSize.UseMarkup = true;
	 		labelSize.Markup = "<b>Size:</b>";
	 	*/
	 		labelSize.Text = "Size:";
	 	hboxnbinfo1.PackStart (labelSize, false, true, 5);
	 		labelR1 = new Label();
	 		labelR1.Text = "R1";
	 	hboxnbinfo1.PackStart (labelR1, false, true, 5);
	 		Label labelFiles = new Label();
	 		labelFiles.Text = "Files:";
	 	hboxnbinfo1.PackStart (labelFiles, false, true, 5);
	 		labelR2 = new Label();
	 		labelR2.Text = "R2";
	 	hboxnbinfo1.PackStart (labelR2, false, true, 5);
	 		Label labelFolders = new Label();
	 		labelFolders.Text = "Folders:";
	 	hboxnbinfo1.PackStart (labelFolders, false, true, 5);	
	 		labelR3 = new Label();
	 		labelR3.Text = "R3";
	 	hboxnbinfo1.PackStart (labelR3, false, true, 5);	 	
	 	
	 	vboxnb3.PackStart (hboxnbinfo1, true, true, 0);
 	
	 	HBox hboxnbinfo4 = new HBox (false, 0);
 		Label labelxbe = new Label();
 		labelxbe.Text = "New Title:";
	 	hboxnbinfo4.PackStart (labelxbe, false, false, 5);
 		Entrygamexbe = new Entry();
 		Entrygamexbe.Text = "xbename";
  		Entrygamexbe.Activated += new EventHandler (OnEntrygamexbeActivated);
 		tooltips.SetTip (Entrygamexbe,
                        " Press Enter to valid ",
                        "");
	 	Entrygamexbe.MaxLength = 42;
	 	Entrygamexbe.WidthRequest = 255;
	 	hboxnbinfo4.PackStart (Entrygamexbe, false, false, 10);
	 	
	 	vboxnb3.PackStart (hboxnbinfo4, true, true, 0);
	 		
	 	HBox hboxnbinfo2 = new HBox (false, 0);
 		Label labelMain = new Label();
 		labelMain.Text = "Main Folder:";
	 	hboxnbinfo2.PackStart (labelMain, false, false, 5);
 		Entryxboxdir = new Entry();
 		Entryxboxdir.Text = "xboxdir";
  		Entryxboxdir.Activated += new EventHandler (OnEntryxboxdirActivated);
 		tooltips.SetTip (Entryxboxdir,
                        " (Evolution-X: 'E', XBMC: 'E:', Avalaunch: 'E:') Press Enter to valid",
                        "");
 		
	 	Entryxboxdir.WidthRequest = 255;
	 	hboxnbinfo2.PackStart (Entryxboxdir, false, false, 10);
 	/*	Label labelHelp = new Label();
 		labelHelp.Text = "(Evolution-X: 'E', XBMC: 'E:', Avalaunch: 'E:')";
	 	hboxnbinfo2.PackStart (labelHelp, false, false, 5);
	*/ 	
		vboxnb3.PackStart (hboxnbinfo2, true, true, 0);
		
	 	HBox hboxnbinfo3 = new HBox (false, 0);
 		Label labelGame = new Label();
 		labelGame.Text = "Game Folder:";
	 	
 		hboxnbinfo3.PackStart (labelGame, false, false, 5);
 		
	 	Entrygamedir = new Entry();
 		Entrygamedir.Text = "gamedir";
  		Entrygamedir.Activated += new EventHandler (OnEntrygamedirActivated);
 		tooltips.SetTip (Entrygamedir,
                        " Press Enter to valid ",
                        "");
	 	Entrygamedir.MaxLength = 42;
	 	Entrygamedir.WidthRequest = 255;
	 	hboxnbinfo3.PackStart (Entrygamedir, false, false, 10);
 	
	 	// New To multi xbox support
 		Label labelXboxs = new Label();
		labelXboxs.Text = "To Xbox:";
		hboxnbinfo3.PackStart (labelXboxs, false, false, 5);
		XboxsConnectionCombo = new ComboBox ();
	 	// End  New To multi xbox support			
	 	hboxnbinfo3.PackStart (XboxsConnectionCombo, false, false, 10);


		vboxnb3.PackStart (hboxnbinfo3, false, false, 0);		

		#endregion
		
	 		frameTransfertOptions.Add(vboxnb3);
	 		
	 		// Add a frame with Batch Info view
			Frame frameBatchInfo = new Frame (" Batch Info ");
			frameBatchInfo.BorderWidth = 5;

			hboxnb6.PackStart (frameBatchInfo, false, true, 5);

	 		#region	 BatchInfo
	 		VBox vboxBatchInfo = new VBox (false, 0);	 		
	 		frameBatchInfo.Add (vboxBatchInfo);

	 		Table tablebatchinfo = new Table (3, 2, true);
	 		tablebatchinfo.Homogeneous = true;
			vboxBatchInfo.PackStart (tablebatchinfo, true, true, 5);
			
			Label labelbatchentry = new Label ("Batch Entry: ");
			labelbatchentry.SetAlignment(1,1);
			tablebatchinfo.Attach (labelbatchentry, 0, 1, 0, 1);

			Label labelbatchsize = new Label ("Batch Size: ");
			labelbatchsize.SetAlignment(1,2);
			tablebatchinfo.Attach (labelbatchsize, 0, 1, 0, 2);

			Label labelbatchfile = new Label ("Batch Files: ");
			labelbatchfile.SetAlignment(1,3);
			tablebatchinfo.Attach (labelbatchfile, 0, 1, 0, 3);
			
			labelnbbatchentry = new Label ("nbBatchEntry");
			labelnbbatchentry.SetAlignment(0,1);
			tablebatchinfo.Attach (labelnbbatchentry, 1, 2, 0, 1);

			labelnbbatchsize = new Label ("nbBatchSize");
			labelnbbatchsize.SetAlignment(0,2);
			tablebatchinfo.Attach (labelnbbatchsize, 1, 2, 0, 2);		

			labelnbbatchfiles = new Label ("nbBatchFiles");
			labelnbbatchfiles.SetAlignment(0,3);
			tablebatchinfo.Attach (labelnbbatchfiles, 1, 2, 0, 3);
			#endregion BatchInfo
			
			halticons = new CheckButton();
			halticons.Label = "Shutdown XBOX After Transfert";
			halticons.Active = false;
			vboxBatchInfo.PackStart (halticons, true, true, 5);
			
			#endregion		
//======================================
/*
//=================================================
// 			NoteBook 3 Save Manager
			#region NoteBook 3
			
			VBox vboxnb5 = new VBox (false, 0);
	 		nb.Add(vboxnb5);
	 		nb.SetTabLabelText(vboxnb5, "Save Manager");
		
			Toolbar toolbar4 = CreateToolbar.CreateSaveToolbar ();
			vboxnb4.PackStart (toolbar4, false, false, 0);
			
	 		// Add a frame with a label Title view
			Frame frame4 = new Frame (" Source ");
			frame4.BorderWidth = 4;
			vboxnb5.PackStart (frame4, false, false, 0);
			                   
			HBox hbox = new HBox (false, 2);
			hbox.BorderWidth = 5;
			frame4.Add(hbox);
					
			Button btn = new Button ("Create ISO");
			btn.Clicked += new EventHandler (OnCreateISOClicked);
			hbox.PackStart (btn, false, false, 0);
	
			// Add a frame with a label Title view
			Frame frame5 = new Frame (" Save Manager ");
			frame5.BorderWidth = 4;
			vboxnb5.PackStart (frame5, false, false, 0);
			
			HBox hbox2 = new HBox (false, 2);
			hbox2.BorderWidth = 5;
			frame5.Add(hbox2);
			
			Button btmd5 = null;
			btmd5 = new Button ("File MD5");
			//btmd5.Clicked += new EventHandler (OnFileMD5Clicked);
			btmd5.CanDefault = true;
			
			hbox2.PackStart(btmd5, false, false, 0);
			
			#endregion
//======================================
*/
//=================================================
// 			NoteBook 4 Log view
			#region NoteBook 4
					
			VBox vboxnb4 = new VBox (false, 0);
	 		nb.Add(vboxnb4);
	 		nb.SetTabLabelText(vboxnb4, "Log view");
		
	 		Toolbar toolbar4 = CreateToolbar.CreateLogToolbar ();
			vboxnb4.PackStart (toolbar4, false, false, 0);

			// Add a frame with a label Title view
			Frame framelogview = new Frame (" Log Messages ");
			framelogview.BorderWidth = 4;
			
			// Add a scrolledWindows for the ISOList
			ScrolledWindow sw3 = new ScrolledWindow ();
			//sw3.BorderWidth = 10;
			sw3.Show();
			framelogview.Add(sw3);
			
			// Add a Text View
			// To make a log view better than console
			textview = new TextView ();
			buf = textview.Buffer;
			textview.Editable = false;
			
			sw3.Add(textview);
			//framelogview.Add(textview);

			vboxnb4.PackStart (framelogview, true, true, 0);
			
			#endregion
//======================================

			CurrentGame = new ArrayList();
			
			// Add a status bar
			statusbar = new Statusbar ();
			statusbar.Push (1, "Xbgm# ready.");
			statusbar.Homogeneous = false;
			statuslabelconnexion = new Label(" My Xbox ");
			EventBox ebox = new EventBox ();
			ebox.Add (statuslabelconnexion);
			ebox.ButtonPressEvent += new ButtonPressEventHandler (OnLabelButtonPressEvent);
			tooltips.SetTip (ebox, " Select Active Connection ", "");
			statusbar.PackStart(ebox, false, false, 0);
			OnLineStatusImg = new Gtk.Image(Stock.No, Gtk.IconSize.SmallToolbar);
			statusbar.PackStart(OnLineStatusImg, false, false, 0);
			// END of status bar 
		
			vbox.PackStart (statusbar, false, false, 0);
			//END of first vbox 
		}
		catch(Exception ex)	{ Console.WriteLine(ex.Message); }
		#endregion
		
		// Show the all window
		this.ShowAll();
		this.Present();

		// Init the Xiso Info class
		iso = new XisoInfoClass();
		
		// Show welcome message
		AppendText(NAME + " " + VERSION + " " + WELCOME);
		
		// Init the OLD XBGM configuration
		//cfg = new Configuration();
		
	/*	// Use G Drive
		if (cfg.getGDrive() == false) {
			DriveG.Visible = false;
			labelResultDriveG.Visible = false;
		}
	*/	

		// Set active Xbox in Label Active Connection
		statuslabelconnexion.Text = config.xboxs[Index].name;
		// Set active Xbox inUse G Drive
		DriveG.Visible = config.xboxs[Index].Gdrive;
		labelResultDriveG.Visible = config.xboxs[Index].Gdrive;

		Entrygamexbe.Hide();
		Entrygamedir.Hide();
		Entryxboxdir.Hide();
		labelDashboard.Hide();
		XboxsConnectionCombo.Hide();
		
	/*	//If linux no thread in game manager
		if (Environment.OSVersion.Platform.ToString().StartsWith("Win"))
			Linux = false;
		else
			Linux = true;
	*/} // End of Constructor
	
	void OnMyWindowDelete (object o, DeleteEventArgs args)
	{
		/*Mail mymail = new Mail();
		string file = "debug.txt";
		if (Environment.OSVersion.Platform.ToString().StartsWith("Win")) {
			file = Environment.GetEnvironmentVariable("USERPROFILE") + "\\xbgmsharp\\debug.txt";
		} else {
			file = Environment.GetEnvironmentVariable("HOME") + "/.xbgmsharp/debug.txt";
		}
		System.Text.StringBuilder StringBuild = new System.Text.StringBuilder ();
		StringBuild.Append(file);
		mymail.SendMail(StringBuild, "XBGM# Report", "xbgm@kayaweed.net", "xbgm@kayaweed.net", "127.0.0.1", false);
		*/
		Application.Quit ();
		System.Environment.Exit (0);
	}

		#region OnToolbarTopClicked
		public  void OnToolbarPrefClicked ()
		{
			PrefGladeDialog login = new PrefGladeDialog ();
			
			// set conf value to preference dialog
			//if (cfg.ReadConf() == true)	{ login.setConfiguration(cfg); }
			
			if ((int)ResponseType.Ok == login.Run())
			{
			//	cfg.set(login.getConfiguration());
			//	cfg.SaveConf();
				config = login.config; // Get the modification
				//Console.WriteLine("===============\n OnToolbarPrefClicked\n");
				//config.Print();
				// Set Default Xbox active connection 
				// Active Connection & G Drive	
				config.SetDefaultToActive();
				int Index = config.GetIndexActive();
				// Set active Xbox in Label Active Connection
				statuslabelconnexion.Text = config.xboxs[Index].name;
				// Set active Xbox in Use G Drive
				DriveG.Visible = config.xboxs[Index].Gdrive;
				labelResultDriveG.Visible = config.xboxs[Index].Gdrive;
				this.ftpToXbox.config = config; // Set the config modification to ftpToXbox
				//Console.WriteLine("===============\n OnToolbarPrefClicked from this.ftpToXbox.config:\n");
				//this.ftpToXbox.config.Print();
			}
			//login.Close();			
			login = null;
		}

		public  void OnToolbarXBMCClicked()
		{
			try 
			{
				//if (!ReadConf()) return;
				// Do xbox Stuff
				this.ftpToXbox.ActionNotOnGame(FtpToXbox.Action.xbmc);
				AppendText("Xbox Media Center Start");
			}
			catch (Exception ex)
			{
				#if (DEBUG)
				Console.WriteLine("Exception (in MyWindow): " + ex.Message);
				#endif
				popup.Error(ex.Message);
			}
		}
		
		public  void OnToolbarShutdownClicked()
		{
			try 
			{
				//if(!ReadConf())	return;	
				// Do xbox Stuff
				ftpToXbox.ActionNotOnGame(FtpToXbox.Action.shutdown);
				AppendText("Xbox Shutdown");
			}
			catch (Exception ex)
			{
				#if (DEBUG)
				Console.WriteLine("Exception (in MyWindow::OnToolbarShutdownClicked): " + ex.Message);
				#endif
				popup.Error(ex.Message);
			}
		}

		public  void OnToolbarRestartClicked()
		{
			try 
			{
				// Check Conf
				//if(!ReadConf()) return;
					
				// Update configuration in the ftp connection controller
				//ftpToXbox.setConfiguration(cfg);

				// Do xbox Stuff
				ftpToXbox.ActionNotOnGame(FtpToXbox.Action.reboot);
				AppendText("Xbox Reboot");
			}
			catch (Exception ex)
			{
				#if (DEBUG)
				Console.WriteLine("Exception (in MyWindow::OnToolbarRestartClicked): " + ex.Message);
				#endif
				popup.Error(ex.Message);
			}
		}
		
		public  void OnToolbarAboutClicked()
		{
			AboutDialog about = new AboutDialog (this, VERSION);
			#if ( DEBUG )
				Console.WriteLine("Got AboutDialog");	
			#endif	
			about.Run();
			about.Close();
			about = null;
		}
		#endregion

		#region OnToolbarGameClicked
		public  void OnToolbarScanTitlesClicked ()
		{	
			/*if (!ReadConf())
			{
				Console.WriteLine("Failed reading the config, not good!");
				return;
			}
			*/
			// Clear the Liststore
			store.Clear();
			//ftpToXbox.config = config;
			// Ask for cache if Active in configuration
	/*		if (cache == true) 
			{
				System.Text.StringBuilder StringBuild = new System.Text.StringBuilder ();
				StringBuild.Append("Do you wish to use cache?");
				
				MessageDialog md = new MessageDialog (this, 
				                                      DialogFlags.DestroyWithParent, 
				                                      MessageType.Question, 
				                                      ButtonsType.YesNo, 
				                                      StringBuild.ToString());			
				// need to check what the user choose.
				int result = md.Run ();
				md.Hide ();
				md.Dispose ();
				md.Destroy ();
				StringBuild = null;
				if (result  == (int)ResponseType.Yes)
				{
		*/				
						// So you want to use cache.
						//cache = true;
						
						// Get the Game listing for the Xbox or cache			
						//if(cfg.getCache())
						if (config.cachetitles)
						{
							#if ( DEBUG )
								Console.WriteLine("Use cache, parse it...");
							#endif
							AppendText("Use cache to list Xbox Game");
							// if we use cache we have a titles files and icons
							//labelAllFreespaceResult.Text = ftpToXbox.GetTitlesCached();
							ftpToXbox.GetTitlesCached();

							if(Convert.ToInt32(ftpToXbox.gameSummary.nbTitles) < 1 ||
								ftpToXbox.gameSummary.info == null)
							{
								#if ( DEBUG )
									Console.WriteLine("Use cache but NOT Found launch FTP");
								#endif
							} else {
								updateSummary(ftpToXbox.gameSummary);
								return;
							}
						}
						
						// Default case when cache is set to false
						if(Convert.ToInt32(ftpToXbox.gameSummary.nbTitles) < 1 || config.cachetitles == false)
						{
							try
							{
								/*
								if (!ftpToXbox.CheckIfAvalaunch()) {
									popup.Error(ftpToXbox.MsgError);
									return;
								}
								*/ // New 0.9.0.8_dbg1
								labelDashboard.Visible = true;
								if (ftpToXbox.CheckDashboard() == false) {
									popup.Error(ftpToXbox.MsgError);
									labelDashboard.Text = ftpToXbox.Msg;
									return;
								}
								labelDashboard.Text = ftpToXbox.Msg;
							}
							catch (Exception ex)
							{
								#if (DEBUG)
									Console.WriteLine("Exception (in MyWindow::OnToolbarScanTitlesClicked): " + ex.Message);
								#endif
								popup.Error(ex.Message);
								return;
							}
							ThreadStart tstart = new ThreadStart (Ftp_Thread);
							ftp_worker = new Thread (tstart);

							ftp_worker.Start();
							main_notify = new Gtk.ThreadNotify (new Gtk.ReadyEvent (UpdateSummaryThread));
							/*
							if (Linux == false)
							{
								ftp_worker.Start();
								main_notify = new Gtk.ThreadNotify (new Gtk.ReadyEvent (UpdateSummaryThread));
							}
							else
							{
								Ftp_Thread();
								ftpToXbox.action = FtpToXbox.Action.ready;
							}
							*/
						}
	/*			}
				if (result  == (int)ResponseType.No)
				{
					#if ( DEBUG )
						Console.WriteLine("NOT Use cache");
					#endif
					t1.Start();	
				}
			}
			else
			{
				#if ( DEBUG )
					Console.WriteLine("NOT ask cache");
				#endif
				t1.Start();
			}
	*/		
		}

		/// <summary>
		/// Event received from FtpToXBox.	
		/// WakeUp Main thread.
		/// </summary>
		public void EventFtpThread (object sender, EventArgs args)
		{
			#if ( DEBUG )
			Console.WriteLine("In EventFtpThread");
			#endif
			main_notify.WakeupMain();
		}
		
		/// <summary>
		/// Update GUI from the main thread.
		/// Update the status bar
		/// Show what we are doing when getting game titles info
		/// </summary>
		void UpdateSummaryThread ()
		{
			#if ( DEBUG )
			Console.WriteLine("In UpdateSummaryThread");
			#endif
			if (ftpToXbox.action == FtpToXbox.Action.image)
				statusbar.Push (1 , "Getting Images....");
			else if (ftpToXbox.action == FtpToXbox.Action.scan)
				statusbar.Push (1 , "Scanning Titles....");
			else if (ftpToXbox.action == FtpToXbox.Action.allfreespace)
				statusbar.Push (1 , "Getting FreeSpace for all Drive....");
			else if (ftpToXbox.action == FtpToXbox.Action.freespace)
				statusbar.Push (1 , "Getting FreeSpace for Game Drive....");
			else if (ftpToXbox.action == FtpToXbox.Action.refresh)
				statusbar.Push (1 , "Refreshing Game Menu....");
			else if (ftpToXbox.action == FtpToXbox.Action.connect) 
			{
				int Index = config.GetIndexActive();
				statusbar.Push (1 , "Connecting to " + config.xboxs[Index].name + 
				                " with IP " + config.xboxs[Index].ip + "....");
			}
			else if (ftpToXbox.action == FtpToXbox.Action.ready)
			{
				statusbar.Push (1 , "XBGM# Ready.");
				if ( ftpToXbox.gameSummary.nbTitles != 0 & ftpToXbox.Rootspace != null 
				    & ftpToXbox.Done == false) {
					updateSummary(ftpToXbox.gameSummary);
					updateLabelResults(ftpToXbox.Rootspace);
					ftpToXbox.Done = true;
				}
				LogMsg(ftpToXbox.Msg);
			}
			else if (ftpToXbox.action == FtpToXbox.Action.error)
			{
				statusbar.Push (1 , "XBGM# Error.");
				popup.Error(ftpToXbox.MsgError);
				ftpToXbox.action = FtpToXbox.Action.ready;
			}
			OnLine(ftpToXbox.Online);
			while (Application.EventsPending ())
				Application.RunIteration ();
		}

		/// <summary>
		/// Launch job in ftp thread.
		/// </summary>
		private void Ftp_Thread()
		{
			try
			{
				#if ( DEBUG )
				Console.WriteLine("In Ftp_Thread");
				#endif
				ftpToXbox.Done = false;
				ftpToXbox.In_Thread = true;
				//labelAllFreespaceResult.Text = ftpToXbox.GetTitles(DLicons.Active);			
				ftpToXbox.GetTitles(DLicons.Active);
				// Kill the thread because we are done
			    ftp_worker.Abort();
				ftpToXbox.In_Thread = false;
				ftpToXbox.Online = false;
				ftpToXbox.action = FtpToXbox.Action.ready;
				#if ( DEBUG )	
				Console.WriteLine("End Ftp_Thread");
				#endif
			}
			catch (Exception ex)
			{
				#if (DEBUG)
					Console.WriteLine("Exception (in MyWindow::Ftp_Thread): " + ex.Message);
				#endif
				ftpToXbox.Online = false;
				ftpToXbox.action = FtpToXbox.Action.ready;
				// make sure we Kill the thread
				ftp_worker.Abort();
				ftpToXbox.In_Thread = false;
				//throw e;
			}		
		}
		
		public  void OnToolbarLaunchClicked()
		{
			// Launch Game by FTP Command
			if (CurrentGame.Count != 0)
			{
				#if ( DEBUG )	
				{
					Console.WriteLine(CurrentGame[0]);
					Console.WriteLine(CurrentGame[1]);
					Console.WriteLine(CurrentGame[2]);
					Console.WriteLine(CurrentGame[3]);
					//Console.WriteLine("user: \"" + ftpinfo.getUser() + "\" pass: \"" + ftpinfo.getPassword() + "\" IP: \"" + ftpinfo.getIp() + "\" Dir: \"" + ftpinfo.getDirectory + "\"");
				}
				#endif
				// DO xbox FTp stuff
				if (ftpToXbox.LaunchGame(CurrentGame))
				{
					// tell the user the game as been launch
					popup.Info(CurrentGame[0] + " Launched");
					AppendText(CurrentGame[0] + " Launched");
				}	
			}
		}
		
		public  void OnToolbarLaunchClicked(object o, EventArgs args)
		{
			OnToolbarLaunchClicked();
		}
				
		public  void OnToolbarDeleteClicked ()
		{
			if (CurrentGame.Count != 0)
			{
				#if ( DEBUG )
					Console.WriteLine(CurrentGame[2]);
				#endif

				DeleteDialog login = new DeleteDialog (CurrentGame[0].ToString());
				int nRc = login.Run();
				#if ( DEBUG )
					Console.WriteLine("Got DeleteDialog");	
				#endif
				if (login.action == 1)
					deletesave = false;
				if (login.action == 2)
					deletesave = true;
				if (login.action == 3)
					deletesave = true;
				
				login.Close();
				login = null;
				if(nRc == (int)ResponseType.Ok) {
					// DO xbox FTp stuff
					ftpToXbox.DeleteGame(CurrentGame, deletesave);
					AppendText("Game " + CurrentGame[0].ToString() + " deleted");
				}
			}
		}		

		private void OnToolbarDeleteClicked(object o, EventArgs args)
		{
			OnToolbarDeleteClicked();
		}
		
		public  void OnToolbarRenameClicked ()
		{
			if (CurrentGame.Count != 0)
			{
				RenameDialog login = new RenameDialog (CurrentGame[0].ToString());
				int nRc = login.Run();
				#if ( DEBUG )
					Console.WriteLine("Got RenameDialog");	
				#endif
				string newgamename  = login.Game;
				#if ( DEBUG )
					Console.WriteLine("New name: " + newgamename);
				#endif
				login.Close();
				login = null;
				
				if(nRc == (int)ResponseType.Ok) {
					// Do xbox FTP stuff
					if (ftpToXbox.RenameGame(CurrentGame, newgamename))
					{
						AppendText("Game " + CurrentGame[0].ToString() + " rename to " + newgamename);
					}
				}
			}
		}

		private void OnToolbarRenameClicked(object o, EventArgs args)
		{
			OnToolbarRenameClicked();
		}
		
		public  void OnToolbarExportClicked ()
		{
			if (CurrentGame.Count != 0)
			{
				MyChooserDialog chooserdialog = new MyChooserDialog(this);
				ResponseType response = chooserdialog.SaveAsDialog("Export Game List to Html.");
				chooserdialog.Hide();
				if ((response == ResponseType.Ok) && chooserdialog.FileName.Length != 0)
				{
					#if ( DEBUG )
						Console.WriteLine(chooserdialog.FileName);
					#endif
					ExportTo exportto = new ExportTo(popup);
					exportto.HTML(chooserdialog.FileName, store, iter);
					exportto = null;
				}
				chooserdialog.Close();
				chooserdialog = null;
			}
		}
		#endregion
		
		#region OnToolbarISOClicked
		public  void OnToolbarOpenISOClicked ()
		{
			// Check Conf
			//if(!ReadConf())
			//	return;
			MyChooserDialog chooserdialog = new MyChooserDialog(this);
			ResponseType response = chooserdialog.OpenFileDialog("Choose a ISO file.");
			#if ( DEBUG )
			Console.WriteLine("FileChooserDialog filename = '{0}'", chooserdialog.FileName);
			#endif
			if ((response == ResponseType.Ok) && chooserdialog.FileName.Length != 0)
			{
				iso.xisofilename = chooserdialog.FileName;
				chooserdialog.Hide();
				iso.xbe = true;
				iso.Nbfiles = 0;
				iso.Nbdir = 0;
				iso.totfilesize = 0;
				iso.getfileiniso();
				labelR1.Text = iso.isosize.ToString() + " MB";
				labelR2.Text = iso.Nbfiles.ToString();
				labelR3.Text = iso.Nbdir.ToString();
				Entrygamexbe.Text = iso.GameName;
				//Entryxboxdir.Text = FTPinfo.dir;
				//Entryxboxdir.Text = cfg.getFtpInfo().getDirectory();
				string[] dir = config.GetDirectoryActive();
				Entryxboxdir.Text = dir[0];
				Entrygamedir.Text = iso.GameFolder;
				GenerateXboxsConnectionCombo();
				string[] info = null;
				if(iso.GameRegion == 1)
					info = new string[]{iso.GameName, labelR1.Text, iso.GameFolder, System.IO.Path.GetFileName(iso.xisofilename), "NTSC", Entryxboxdir.Text, iso.Nbfiles.ToString() , iso.Nbdir.ToString(), iso.xisofilename, iso.totfilesize.ToString(), config.GetNameActive()};
				else if(iso.GameRegion == 2)
					info = new string[]{iso.GameName, labelR1.Text, iso.GameFolder, System.IO.Path.GetFileName(iso.xisofilename), "JP", Entryxboxdir.Text, iso.Nbfiles.ToString() , iso.Nbdir.ToString(), iso.xisofilename, iso.totfilesize.ToString(), config.GetNameActive()};
				else if(iso.GameRegion == 4)
					info = new string[]{iso.GameName, labelR1.Text, iso.GameFolder, System.IO.Path.GetFileName(iso.xisofilename), "PAL", Entryxboxdir.Text, iso.Nbfiles.ToString() , iso.Nbdir.ToString(), iso.xisofilename, iso.totfilesize.ToString(), config.GetNameActive()};
				else
					info = new string[]{iso.GameName, labelR1.Text, iso.GameFolder, System.IO.Path.GetFileName(iso.xisofilename), "Mix", Entryxboxdir.Text, iso.Nbfiles.ToString() , iso.Nbdir.ToString(), iso.xisofilename, iso.totfilesize.ToString(), config.GetNameActive()};
				AddISOInfoToRow(info);
				RefreshBatchInfo();
				// Show entry
				Entrygamexbe.Visible = true;
				Entryxboxdir.Visible = true;
				Entrygamedir.Visible = true;
				XboxsConnectionCombo.Visible = true;
				XboxsConnectionCombo.Show();
				info = null;			
			}
			chooserdialog.Close();
			chooserdialog = null;
		}

		public  void OnToolbarUploadISOClicked ()
		{
			//if (iso.xisofilename != null)
			store2.GetIterFirst(out iter2);
			if (store2.IterIsValid(iter2))
			{
				 // Comment because i don't know where to get params, should in extract xiso
		/*		// Check Free space before Upload
				bool freespace = ftpToXbox.GetFreeSpace(string xboxDir, UInt32 size)
				if (freespace == true) // IF enought space
		*/		
				if( !ExtractXiso() )
				{	// Do not refresh Avalaunch menu else xbgm# will freeze
					#if (DEBUG)
					Console.WriteLine("Extraction cancelled!");
					#endif
					return;
				}
				else 
				{
					// Refresh Avalaunch Menu
					try
					{
						ftpToXbox.ActionNotOnGame(FtpToXbox.Action.refresh);
					}
					catch (Exception ex)
					{
						#if (DEBUG)
						Console.WriteLine("Exception (in MyWindow::OnToolbarUploadISOClicked): " + ex.Message);
						#endif
						popup.Error(ex.Message);
					}
				}
				// Check if i need to Shutdown Xbox
				if (halticons.Active == true) {
					// Shutdown Xbox
					ftpToXbox.ActionNotOnGame(FtpToXbox.Action.shutdown);
				}
				#if ( DEBUG )
				Console.WriteLine("End UploadISO");
				#endif
				AppendText(buf, "End Upload xISO");
			}
			else
			{
			  AppendText(buf, "You need to select an xISO file.");
			  popup.Info("You need to select an xISO file.");
			}
		}

		public  void OnToolbarExtractISOClicked ()
		{ 
			MyChooserDialog chooserdialog = new MyChooserDialog(this);
			ResponseType response = chooserdialog.OpenFileDialog("Choose a ISO file.");
			#if ( DEBUG )
				Console.WriteLine("FileChooserDialog filename = '{0}'", chooserdialog.FileName);
			#endif
			if ((response == ResponseType.Ok) &&  chooserdialog.FileName.Length != 0)
			{
				string Filename = chooserdialog.FileName;
				chooserdialog.Close();
				chooserdialog.SelectDirDialog("Choose a Destination Directory.");
				#if ( DEBUG )
					Console.WriteLine("DirChooserDialog filename = '{0}'", chooserdialog.FileName);
				#endif
				string Destdir = chooserdialog.FileName;
				chooserdialog.Hide();	
				if (Destdir.Length != 0)
				{
					#if ( DEBUG )
						Console.WriteLine("File : [" + Filename + "] Dir: [" + Destdir + "]");
					#endif
					// Save current path before hdd extracting
					string currentdir = Directory.GetCurrentDirectory();
					iso.xisofilename = Filename;
					iso.GameRootFolder = Destdir;
					iso.xbe = false;
					iso.Nbfiles = 0;
					iso.totfilesize = 0;
					iso.getfileiniso();
					string gameextractdir = System.IO.Path.GetFileName(Filename);
					gameextractdir = gameextractdir.Substring(0 ,System.IO.Path.GetFileName(Filename).LastIndexOf('.'));
					iso.GameFolder = gameextractdir;
					gameextractdir = null;
					ExtractXiso();
					// Restore the old current path
					Directory.SetCurrentDirectory(currentdir);
					currentdir = null;
					iso.xisofilename = iso.GameRootFolder = iso.GameName = iso.GameFolder = null;
				}
			}
			chooserdialog.Close();	
			chooserdialog = null;
		}

		public  void OnToolbarUploadDirClicked ()
		{ 
			UploadDirGladeDialog uploaddirdialog = new UploadDirGladeDialog(config, this);

			//uploaddirdialog.Close();
			//uploaddirdialog = null;
		}
		
		public  void OnToolbarClearBatchClicked ()
		{ 
			store2.Clear();
			RefreshBatchInfo();
			labelR1.Text  = "0";
			labelR2.Text = "0";
			labelR3.Text = "0";
			Entrygamexbe.Text = "";
			Entryxboxdir.Text = "";
			Entrygamedir.Text = "";
			Entrygamexbe.Hide();
			Entrygamedir.Hide();
			Entryxboxdir.Hide();
			XboxsConnectionCombo.Hide();
		}
		#endregion

		#region OnToolbarLogClicked
		public  void OnToolbarClearLogClicked()
		{
			textview.Buffer.Clear();
		}
		
		public  void OnToolbarSaveLogClicked ()
		{
			MyChooserDialog chooserdialog = new MyChooserDialog(this);
			ResponseType response = chooserdialog.SaveAsDialog("Export Log view to Text.");
			chooserdialog.Hide();
			if ((response == ResponseType.Ok) && chooserdialog.FileName.Length != 0)
			{
				#if ( DEBUG )
					Console.WriteLine(chooserdialog.FileName);
				#endif
				StreamWriter outputFilestream = null;
				try {
					outputFilestream = new StreamWriter(chooserdialog.FileName);
				}
				catch(Exception e) {
					Console.WriteLine("Error: Unable to create output log file. " + e.Message);
					return;
				}
				outputFilestream.WriteLine(textview.Buffer.Text);		
				outputFilestream.Close();
				outputFilestream = null;
				#if ( DEBUG )
					Console.WriteLine("Outputting log to file done.");
				#endif
				popup.Info("Log message save to file \n" + System.IO.Path.GetFileName(chooserdialog.FileName));
				AppendText("Log message save to file " + System.IO.Path.GetFileName(chooserdialog.FileName));
			}
			chooserdialog.Close();
			chooserdialog = null;
		}
		#endregion
		
		#region Append Text to Log View
		void AppendText (string text) 
		{
			AppendText (buf, text);
		}
		
		public void AppendTextWithoutScroll (TextBuffer buffer, string text) 
		{
			TextIter iter;
			buffer.MoveMark(buf.InsertMark, buffer.EndIter);
			if(text != null) 
			{
				if (text.Equals ("") == false) 
				{				
					iter = buffer.EndIter;
					buffer.Insert (ref iter, "["+DateTime.Now.ToShortTimeString()+"] >> " + text);
				}
			}
			iter = buffer.EndIter;
			buffer.Insert (ref iter, "\n");
		}

		// WriteLine() to output text to Log TextView
		// for displaying result sets and logging messages
		public void AppendText (TextBuffer buffer, string text) 
		{
			AppendTextWithoutScroll(buffer,text);
			while (Application.EventsPending ()) 
				Application.RunIteration ();
			//textview.ScrollToMark (buf.InsertMark, 0.4, true, 0.0, 1.0);
		}
		#endregion
		
		private bool ExtractXiso()
		{
			// Create the GUI for the stats
			ProgressDialog progress = new ProgressDialog (config);
			// if we parse the xbe then it is extract over network
			double totsizebatchxiso = 0;
			if (iso.xbe == true)
			{
				// Send ListStore Gtk.TreeIter to ProgressDialog
				progress.xISOAdd(store2, iter2);
				// Generate tot size batch iso
				totsizebatchxiso = Convert.ToDouble((string)store2.GetValue(iter2, 9));
				while (store2.IterNext(ref iter2))
				{
					totsizebatchxiso += Convert.ToDouble((string)store2.GetValue(iter2, 9));
				}	
			/*	// Check if we got a / at the end xbox game dir.
				if (Entryxboxdir.Text.Length >= 4 && Entryxboxdir.Text.EndsWith("/") == false)
					Entryxboxdir.Text = Entryxboxdir.Text + "/";
				int Index = config.GetIndexByName((string)store2.GetValue(iter2, 12));
				progress.UpdateFTPinfo(config, Index, Entryxboxdir.Text);
			*/
				//Console.WriteLine("totsifebatchxiso ==>" + totsizebatchxiso + "\n");
				// Set Stats for Batch upload Xiso
				progress.UpdateStatBatchXisos(totsizebatchxiso,
				                              Convert.ToDouble(labelnbbatchentry.Text),
				                              false); // FTpavalaunch
				// Set first Xiso for Batch upload Xiso
				progress.SelectXisoInBatchXisos(false);
			}
			else
			{
				// Set Xiso and batch value for extraction on local
				progress.UpdateXiso(iso.xisofilename, iso.GameRootFolder, iso.GameFolder, iso.Nbfiles, iso.totfilesize, true); // HDD
			}
			// Start timer
			DateTime DtStartNow = DateTime.Now;
			// Do the job
			progress.Run();
			// Stop timer
			DateTime DtStopNow = DateTime.Now;
			// When finish or cancel
			// Kill the dialog box
			progress.Close();
			string tmptime = (DtStopNow - DtStartNow).ToString();
			if (iso.xbe == true)
			{ 	// FTP mode
				if (progress.IsCancel == false)
					popup.Info("Task completed successfully.\n\nTotal xISO: " + labelnbbatchentry.Text + "\nFiles transferred: " + labelnbbatchfiles.Text + "\nTotal bytes transferred: " + (totsizebatchxiso/1024).ToString("####") + " Kb\nElapsed time: " + tmptime.Substring(0, tmptime.LastIndexOf('.')) 
					           + "\nAverage speed: " + (10000000/1024 * totsizebatchxiso/(DtStopNow.Ticks - DtStartNow.Ticks)).ToString(".##") + " kb/s");
			}
			else
			{	// HDD Mode
				if (progress.IsCancel == false)
					popup.Info("Task completed successfully.\n\nTotal bytes transferred: " + (iso.totfilesize/1024) + " KB\nFiles Transferred: " + iso.Nbfiles + "\nElapsed time: " + tmptime.Substring(0, tmptime.LastIndexOf('.')) 
						+ "\nAverage speed: " + 10000000/1024 * iso.totfilesize/(DtStopNow.Ticks - DtStartNow.Ticks) + " kb/s");
			}
			if (progress.IsCancel != false)
			{	// if eror while tranferring.
				popup.Info("You cancelled the operation or there has been an error.\n\n" +
							"You will need to reboot the XBOX if your dashboard is Avalaunch.");
				tmptime = null;
				progress = null;
				System.GC.Collect();
				Console.WriteLine("Aborted xISO extraction.\n");
				
				return false;
			}
			tmptime = null;
			progress = null;
			// Can't be null, it is a global.
			// we might need later.
			// iso = null;
			// Ask to clean the memory
			System.GC.Collect();
			#if ( DEBUG )
			Console.WriteLine("End Extract xISO\n");
			#endif
			return true;
		}
		
		#region Treeview_event_right_click Scan Titles
		[GLib.ConnectBefore]
		public void OnTreeviewButtonPressEvent (object o, ButtonPressEventArgs args)
		{
		    Gdk.EventButton eb = args.Event;
			#if ( DEBUG )
				Console.WriteLine ("Button click");
			#endif
			 switch (eb.Button)
            {
                case 3:
                        PopupMenuGame (eb);
                        break;
        		case 1:
        				#if ( DEBUG )
        					Console.WriteLine ("First click");
            			#endif
        				break;
            } 
		}
		
        private void PopupMenuGame (EventButton ev)
        {
        	#if ( DEBUG )
            	Console.WriteLine ("Popup Menu Game!");
            #endif
            menu = null; // Make sure with we rescan config
            if (menu == null)
            {
                    menu = new Menu ();
                    AccelGroup group = new AccelGroup ();
               		ImageMenuItem item;
				
					item = new ImageMenuItem (Stock.Execute, group);
            		item.Activated += new EventHandler (OnToolbarLaunchClicked);
            		menu.Append (item);       	
            	
            		item = new Gtk.ImageMenuItem ("Edit", group);
            		pix = new Gdk.Pixbuf (null, "edit.png");
					new Gtk.Image (pix);
            		item.Image = new Gtk.Image (pix);
            		item.Activated += new EventHandler (OnToolbarRenameClicked);
				    menu.Append (item);

                    item = new ImageMenuItem (Stock.Delete, group);
            		item.Activated += new EventHandler (OnToolbarDeleteClicked);
                    menu.Append (item);                                   	
            }
            
            menu.ShowAll ();
            menu.Popup (null, null, null,
                            (ev != null) ? ev.Button : 0, (ev != null) ? ev.Time : 0);
   		} 
        
        private void PopupMenuCb(object o, PopupMenuArgs args)
        {
        	#if ( DEBUG )
            	Console.WriteLine ("Popup Menu Game Cb!");
            #endif
            PopupMenuGame (null);
        } 
		#endregion
		
		#region Treeview_event_right_click Upload ISO
		[GLib.ConnectBefore]
		public void OnTreeviewUploadISOButtonPressEvent (object o, ButtonPressEventArgs args)
		{
		    Gdk.EventButton eb = args.Event;
			#if ( DEBUG )
				Console.WriteLine ("Button click");
			#endif
			 switch (eb.Button)
            {
                case 3:
                        PopupMenuIso (eb);
                        break;
        		case 1:
        				#if ( DEBUG )
        					Console.WriteLine ("First click");
            			#endif
        				break;
            } 
		}
		
        private void PopupMenuIso (EventButton ev)
        {
        	#if ( DEBUG )
            	Console.WriteLine ("Popup Menu Iso!");
            #endif
            menu = null; // Make sure with we rescan config
            if (menuiso == null)
            {
                    menuiso = new Menu ();
                    AccelGroup group = new AccelGroup ();
               		ImageMenuItem item;
				
				/*	item = new ImageMenuItem (Stock.Delete, group);
            		item.Activated += new EventHandler (OnToolbarDeleteXisoClicked);
            		menuiso.Append (item); // Will be done with the glade UI      	
				*/
                    item = new ImageMenuItem (Stock.Clear, group);
            		item.Activated += new EventHandler (OnToolbarClearBatchClicked);
                    menuiso.Append (item);                                   	
            }
            
            menuiso.ShowAll ();
            menuiso.Popup (null, null, null,
                            (ev != null) ? ev.Button : 0, (ev != null) ? ev.Time : 0);
   		} 
        
        public void OnToolbarClearBatchClicked (object o, EventArgs args)
		{
			OnToolbarClearBatchClicked();
		}
        
        private void PopupMenuIsoCb(object o, PopupMenuArgs args)
        {
        	#if ( DEBUG )
            	Console.WriteLine ("Popup Menu Iso Called!");
            #endif
            PopupMenuIso (null);
        } 
		#endregion
		
		// Each arg is a new column
		public void AddTextToRow (params string[] args)
		{	
			//iter = store.AppendValues(args);
			// Fix bug when sorting column Size
			try {
				iter = store.AppendValues(args[0], Convert.ToInt64(args[1]), args[2], args[3], args[4],
				                         args[5], args[6], args[7], args[8], args[9],
				                        args[10]);
				tv.Model = store;
			}
			catch(Exception e) {
				#if ( DEBUG )
					Console.WriteLine("Error In MyWindow::AddTextToRow\n{0}", e.Message);
				#endif
				AppendText(e.Message);
				return;
			}	
		}		
			
		// Each arg is a new column
		public void AddISOInfoToRow (params string[] args)
		{	
			iter2 = store2.AppendValues(args);
			tv2.Model = store2;
		}
		
		public void RefreshBatchInfo()
		{
			int job = 0;
			int size = 0;
			int files = 0;
			string sel;
			string[] strsize;
			
			if (store2.GetIterFirst(out iter2))
			{
				//tv2.ActivateRow(store2.GetPath(iter2), 0);
				job++;
				sel = (string)store2.GetValue(iter2, 1);
				strsize = sel.Split(' ');
				size = Int32.Parse(strsize[0]);
				files = Int32.Parse((string)store2.GetValue(iter2, 6));
				#if (DEBUG)
					Console.WriteLine(strsize[0].ToString() + "  " + 
				                  (string)store2.GetValue(iter2, 6) + "  " + 
				                  (string)store2.GetValue(iter2, 7));
				#endif
				while (store2.IterNext(ref iter2)) {
					#if (DEBUG) 
						Console.WriteLine((string)store2.GetValue(iter2, 1) + "  " +
					                  (string)store2.GetValue(iter2, 6) + "  " +
					                  (string)store2.GetValue(iter2, 7));
					#endif				
					job++;
					sel = (string)store2.GetValue(iter2, 1);
					strsize = sel.Split(' ');
					size = Int32.Parse(strsize[0]) + size;
					files = Int32.Parse((string)store2.GetValue(iter2, 6)) + files;
				}
			}
			labelnbbatchentry.Text = job.ToString();
			labelnbbatchsize.Text = size.ToString() + " MB";
			labelnbbatchfiles.Text = files.ToString();
			sel = null;
			strsize = null;
		}

		// When press Enter Entrygamexbe modify liststore
		private void OnEntrygamexbeActivated(object o, EventArgs args)
		{
			//Console.WriteLine(Entrygamexbe.Text);
			store2.GetIterFirst(out iter2);
			if (tv2.Selection.IterIsSelected(iter2))
			{
				store2.SetValue(iter2, 0, Entrygamexbe.Text.ToString());
			}
			while (store2.IterNext(ref iter2)) 
			{
				if ( tv2.Selection.IterIsSelected(iter2)) {
					store2.SetValue(iter2, 0, Entrygamexbe.Text.ToString());
				}
			}
		}
		
		// When press Enter Entrygamedir modify liststore
		private void OnEntrygamedirActivated(object o, EventArgs args)
		{
			//Console.WriteLine(Entrygamedir.Text);
			store2.GetIterFirst(out iter2);
			if (tv2.Selection.IterIsSelected(iter2))
			{
				store2.SetValue(iter2, 2, Entrygamedir.Text.ToString());
			}
			while (store2.IterNext(ref iter2)) 
			{
				if ( tv2.Selection.IterIsSelected(iter2)) {
					store2.SetValue(iter2, 2, Entrygamedir.Text.ToString());
				}
			}
		}
		
		// When press Enter Entryxboxdir modify liststore
		private void OnEntryxboxdirActivated(object o, EventArgs args)
		{
			//Console.WriteLine(Entryxboxdir.Text);
			store2.GetIterFirst(out iter2);
			if (tv2.Selection.IterIsSelected(iter2))
			{
				store2.SetValue(iter2, 5, Entryxboxdir.Text.ToString());
			}
			while (store2.IterNext(ref iter2)) 
			{
				if ( tv2.Selection.IterIsSelected(iter2)) {
					store2.SetValue(iter2, 5, Entryxboxdir.Text.ToString());
				}
			}
		}
			
		// Get single selection click on liststore ISO
		private void on_ISOList_selection(object o, EventArgs args)
		{				
			store2.GetIterFirst(out iter2);
			if (tv2.Selection.IterIsSelected(iter2))
			{
				labelR1.Text  = (string)store2.GetValue(iter2, 1);
				labelR2.Text = (string)store2.GetValue(iter2, 6);
				labelR3.Text = (string)store2.GetValue(iter2, 7);
				Entrygamexbe.Text = (string)store2.GetValue(iter2, 0);
				Entryxboxdir.Text = (string)store2.GetValue(iter2, 5);
				Entrygamedir.Text = (string)store2.GetValue(iter2, 2);
				GenerateXboxsConnectionCombo();
				#if (DEBUG) 
					Console.WriteLine((string)store2.GetValue(iter2, 1) + " " + (string)store2.GetValue(iter2, 7)  + " " +(string)store2.GetValue(iter2, 6));
				#endif	
			}
			while (store2.IterNext(ref iter2)) 
			{
				if ( tv2.Selection.IterIsSelected(iter2)) {
				labelR1.Text  = (string)store2.GetValue(iter2, 1);
				labelR2.Text = (string)store2.GetValue(iter2, 6);
				labelR3.Text = (string)store2.GetValue(iter2, 7);
				Entrygamexbe.Text = (string)store2.GetValue(iter2, 0);
				Entryxboxdir.Text = (string)store2.GetValue(iter2, 5);
				Entrygamedir.Text = (string)store2.GetValue(iter2, 2);
				GenerateXboxsConnectionCombo();
				#if (DEBUG) 
					Console.WriteLine((string)store2.GetValue(iter2, 1) + " " + (string)store2.GetValue(iter2, 7)  + " " +(string)store2.GetValue(iter2, 6));
				#endif	
				}
			}

		}
		
		// Get single selection click on liststore
		private void on_List_selection(object o, EventArgs args)
		{	
		    TreeIter iter;
            TreeModel model;

            if (((TreeSelection)o).GetSelected (out model, out iter))
            {
                string sel = (string) model.GetValue (iter, 0);
                labelIDresult.Text = (string)model.GetValue(iter, 6);
				labelSpaceresult.Text = (string)model.GetValue(iter, 7) + " MB";
				labelSlackresult.Text = (string)model.GetValue(iter, 8) + " MB";
				#if ( DEBUG )
					Console.WriteLine("Result selection: " + sel);
				#endif
				UpdateSelectedTitleImage((string)model.GetValue(iter, 6));
				if (CurrentGame != null)
				{
					CurrentGame.Clear();
				}
				// Create my list of the current game with info i need 
				CurrentGame.Add(sel); // name
				CurrentGame.Add((string)model.GetValue(iter, 9)); // XBE
				CurrentGame.Add((string)model.GetValue(iter, 10)); // dir
				CurrentGame.Add(labelIDresult.Text); // ID
				labelPathresult.Text = System.IO.Path.GetDirectoryName(CurrentGame[2].ToString().Substring(0, CurrentGame[2].ToString().LastIndexOf('/')-1));
				#if ( DEBUG )
					Console.WriteLine("Nb info in CurrentGame: " + CurrentGame.Count);
					Console.WriteLine("==> {0},{1},{2},{3}", CurrentGame[0],
					                  CurrentGame[1], CurrentGame[2],
					                  CurrentGame[3]);
				#endif
            }
		}

		// Get Pixbuf from BMP image for title		
	    static Gdk.Pixbuf GetPixbufFromFile (string filename)
	    {
	        try {
	            Pixbuf p = new Pixbuf (filename);
	            return p;
	        } 
	    	catch (GLib.GException e) {
	            //Console.WriteLine (e.GetType ());
	            Console.WriteLine ("Error: Cannot Open image file: {0}", filename);
	            throw e;
	        }
	
	    }
	
		public void UpdateSelectedTitleImage(string id)
		{
			if (DLicons.Active)
			{
				try
				{
					// Bad this is growing in memory for each image pixbuf .
					// event if the image was all ready open
					Pixbuf p = GetPixbufFromFile ("titleimage" + System.IO.Path.DirectorySeparatorChar + id + ".bmp");
					image.Pixbuf = p;
				}	
				catch(Exception e) {
					Console.WriteLine("Error: Unable to open cache icon file:\n" + e.Message);
					AppendText(e.Message);
					return;
				}	
			}
		}
					
		//
		// **** NEW ******
		// since 0.8.0 
		public void updateSummary(Parser.Summary s)
		{
			// Put all result to Label to show All Tiltles info
			labelAlltitlesResult.Text = s.nbTitles.ToString();
			labelAllfilesResult.Text = s.totnbFiles.ToString();
			labelAllfoldersResult.Text = s.totnbFolders.ToString();
			labelAllsizeResult.Text = s.totSizeMb;
			labelAllspaceResult.Text = s.totSpaceMb;
			labelAllslackResult.Text = s.slackMb;
			
			updateGameInformation(s.info);
		}
		
		private void updateGameInformation(ArrayList info)
		{
			// Sort title by game title
			store.SetSortColumnId(0, SortType.Ascending);
			
			#if (DEBUG)
				Console.WriteLine("Number of games: " + info.Count);
			#endif
			
			foreach(string[] game in info)
			{
				AddTextToRow(game);
			}
		}
		
		private void updateLabelResults(string[] rootspace)
		{
			//int Index = config.GetIndexActive();
			foreach(string space in rootspace)
			{
				//Console.WriteLine("Space:" + space + "]");
				string[] free = space.Split(' ');
				if(free[24].Equals("C:"))
				{
					labelResultDriveC.Text = free[26].ToString() + " MB";
				}
				else if(free[24].Equals("E:"))
				{
					labelResultDriveE.Text = free[26].ToString() + " MB";
				}
				else if(free[24].Equals("F:"))
				{
					labelResultDriveF.Text = free[26].ToString() + " MB";
				}
				else if(free[24].Equals("G:"))
				{
					//Console.WriteLine("Space for G:[" + free[26].ToString() + "]");
					labelResultDriveF.Text = free[26].ToString() + " MB";
					labelResultDriveG.Visible = true;
					DriveG.Visible = true;
				}
		/*		else
				{
					labelResultDriveG.Visible = false;
					DriveG.Visible = false;
				}
		*/		free = null;
			}
		}
		
		
		//
		// **** NEW ******
		// since 0.9.0 
		private void LogMsg(string msg)
		{
			AppendText(msg);
		}

		[GLib.ConnectBefore]
		private void OnLabelButtonPressEvent (object o, ButtonPressEventArgs args)
		{
			Gdk.EventButton eb = args.Event;
			#if ( DEBUG )
				Console.WriteLine ("Button OnLabelButtonPressEvent click!");
			#endif
			 switch (eb.Button)
            {
                case 3:
                       PopupConnexion(eb);
                        break;
        		case 1:
        				#if ( DEBUG )
        					Console.WriteLine ("First OnLabelButtonPressEvent click!");
            			#endif
        				break;
            } 
		}
				
        private void PopupConnexion (EventButton ev)
        {
        	#if ( DEBUG )
            	Console.WriteLine ("In PopupPopupConnexion2!");
            #endif
            menu = null; // Make sure with we rescan config 
            if (menu == null)
            {
                    menu = new Menu ();
                    AccelGroup group = new AccelGroup ();
               		
					for(int i = 0; i < config.xboxs.Length; i++){
                    	//Console.WriteLine("Active : " + config.xboxs[i].active + " Name: " + config.xboxs[i].name);
						if (config.xboxs[i].active) { // Active Xbox with icon
							//config.xboxs[i].active = true; // Set to active
							ImageMenuItem item = new Gtk.ImageMenuItem (config.xboxs[i].name, group);
							item.Image = new Gtk.Image (Stock.Apply, IconSize.Menu);
							item.Activated += new EventHandler (OnSwichActiveConnectionClicked);
							menu.Append (item);
						}
						else {
							// Other Xbox with simple menu as Text
			                MenuItem item2 = new MenuItem (config.xboxs[i].name);
			        		item2.Activated += new EventHandler (OnSwichActiveConnectionClicked);
			                menu.Append (item2);                                   	
						}
					}			
            }
            menu.ShowAll ();
            menu.Popup (null, null, null,
                            (ev != null) ? ev.Button : 0, (ev != null) ? ev.Time : 0);
   		}
        
        private void OnSwichActiveConnectionClicked (object o, EventArgs args)
		{
        	#if ( DEBUG )
        		Console.WriteLine ("In OnSwichActiveConnectionClicked!");
            #endif
        	string s = null;
			if (o is MenuItem)
			  s = ((o as MenuItem).Child as Label).Text;
			// Switch Label Text to the active xbox connection
			if (s != null) {
				statuslabelconnexion.Text = s;
				for (int i = 0; i < config.xboxs.Length; i++) {
					// Clean any active connection
					 config.xboxs[i].active = false;
					 if (config.xboxs[i].name.Equals(s)) {
						// Set select connection to Active
						config.xboxs[i].active = true;
						// Use G Drive
						DriveG.Visible = config.xboxs[i].Gdrive;
						labelResultDriveG.Visible = config.xboxs[i].Gdrive;
					}
				}
				#if ( DEBUG )
				Console.WriteLine ("ActiveConnection: {0}", s);
				#endif
			}
		}
		
		private void OnLine (bool online)
		{
		  	#if ( DEBUG )
            	Console.WriteLine ("In OnLine :" + online);
            #endif
            if (online) {
				OnLineStatusImg.Stock = Stock.Yes;
            } else
				OnLineStatusImg.Stock = Stock.No;
		}
	
		/// <summary>
		/// Create the Xbox Connection Option Menu
		/// </summary>
		/// <returns>OptionMenu</returns>
		private void GenerateXboxsConnectionCombo() 
		{
		   	//Make Xbox List
		   	XboxsConnectionCombo.Clear();
		   	ListStore liststore = new Gtk.ListStore (typeof(string));
		   	XboxsConnectionCombo.Model = liststore;
			CellRendererText  cell = new Gtk.CellRendererText();
			XboxsConnectionCombo.PackStart(cell, true);
			XboxsConnectionCombo.AddAttribute(cell, "text", 0);
			for (int i = 0; i< config.xboxs.Length; i++) {
				XboxsConnectionCombo.AppendText(config.xboxs[i].name);
			}
			XboxsConnectionCombo.Changed += new EventHandler (OnConnectionComboActivated);
		}
		
		private void OnConnectionComboActivated (object o, EventArgs args) 
		{
			XboxsConnectionCombo.GetActiveIter(out xboxsiter);		
		  	#if ( DEBUG )
				Console.WriteLine (XboxsConnectionCombo.Model.GetValue(xboxsiter, 0).ToString());
            #endif
			store2.GetIterFirst(out iter2);
			if (tv2.Selection.IterIsSelected(iter2))
			{
				store2.SetValue(iter2, 10, XboxsConnectionCombo.Model.GetValue(xboxsiter, 0).ToString());
			}
			while (store2.IterNext(ref iter2)) 
			{
				if ( tv2.Selection.IterIsSelected(iter2)) {
					store2.SetValue(iter2, 10, XboxsConnectionCombo.Model.GetValue(xboxsiter, 0).ToString());
				}
			}
		}
		
		/*
		private bool ReadConf()
		{
			cfg.ReadConf();

			// Check Conf
			if(cfg.getFtpInfo().getIp() == null)
				return false;

			// Update configuration in the ftp connection controller
			ftpToXbox.setConfiguration(cfg);

			return true;
		}
		*/
	}
} // End NameSpace
